/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>



#define VER         "0.1.1"
#define KEYPATH     "Software\\ActivePost"
#define BUFFSZ      512
#define REG_IT(x)   len = BUFFSZ; \
                    if(RegQueryValueEx( \
                      key, \
                      x, \
                      NULL, \
                      NULL, \
                      buff, \
                      (void *)&len)) { \
                        fputs("\nError: impossible to read the registry key\n", stdout); \
                        fputs("\n  Press RETURN to exit\n", stdout); \
                        fgetc(stdin); \
                        exit(1); \
                    }



void activepost_pwd(unsigned char *data, int len);



int main(void) {
    HKEY    key;
    char    buff[BUFFSZ];
    int     len;


    setbuf(stdout, NULL);

    fputs("\n"
        "ActivePost Standard user and password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, KEYPATH, 0, KEY_READ, &key)) {
        fputs("\nError: registry key has not been found\n", stdout);
        fputs("\n  Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }

    REG_IT("ID_SAVE");
    activepost_pwd(buff, len);
    printf("   Username:   %s\n", buff);

    REG_IT("ID_PASS");
    activepost_pwd(buff, len);
    printf("   Password:   %s\n", buff);

    RegCloseKey(key);

    fputs("\n  Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void activepost_pwd(unsigned char *data, int len) {
    unsigned short  num = 4989;
    int             tmp;
    unsigned char   *out;

    out = data;
    len >>= 1;
    while(len--) {
        sscanf(data, "%02X", &tmp);
        *out++ = tmp ^ (num >> 8);
        num = ((num + tmp) * 4896) + 15239;
        data += 2;
    }
    *out = 0;
}


